// Part of DTSource. Copyright 2004-2012. David Adalsteinsson.  BSD License
// see http://www.visualdatatools.com/DTSource/license.html for more information.

#ifndef DTFloatArrayOperators_Header
#define DTFloatArrayOperators_Header

#include "DTFloatArray.h"

// Array operator Array
extern DTMutableFloatArray operator+(const DTFloatArray &A,const DTFloatArray &B);
extern DTMutableFloatArray operator-(const DTFloatArray &A,const DTFloatArray &B);
extern DTMutableFloatArray operator*(const DTFloatArray &A,const DTFloatArray &B);
extern DTMutableFloatArray operator/(const DTFloatArray &A,const DTFloatArray &B);

// Array operator Number
extern DTMutableFloatArray operator+(const DTFloatArray &A,double b);
extern DTMutableFloatArray operator-(const DTFloatArray &A,double b);
extern DTMutableFloatArray operator*(const DTFloatArray &A,double b);
extern DTMutableFloatArray operator/(const DTFloatArray &A,double b);

// Number operator Array
extern DTMutableFloatArray operator+(double a,const DTFloatArray &B);
extern DTMutableFloatArray operator-(double a,const DTFloatArray &B);
extern DTMutableFloatArray operator*(double a,const DTFloatArray &B);
extern DTMutableFloatArray operator/(double a,const DTFloatArray &B);

// Negating
extern DTMutableFloatArray operator-(const DTFloatArray &A);

#endif
