// Part of DTSource. Copyright 2004-2012. David Adalsteinsson.  BSD License
// see http://www.visualdatatools.com/DTSource/license.html for more information.

#include "DTSaveError.h"
#include "DTError.h"
#include "DTDataStorage.h"
#include "DTUCharArray.h"

#include "DTIntArray.h"

void DTSaveError(DTDataStorage &output,const string &name)
{
    vector<string> &list = DTErrorList();

    // Find total length
    int totalLength = 0;
    unsigned int i;
    int thisLength;
    for (i=0;i<list.size();i++) {
        thisLength = list[i].length();
        totalLength += thisLength+1;
    }

    // Combine the strings into a single character array.
    DTMutableUCharArray theCombinedStrings(totalLength);
    DTMutableIntArray offs(list.size());
    unsigned char *combP = theCombinedStrings.Pointer();
    int posInCombined = 0;
    string thisString;
    for (i=0;i<list.size();i++) {
        thisString = list[i];
        thisLength = list[i].length();
        memcpy(combP+posInCombined,thisString.c_str(),thisLength+1);
        offs(i) = posInCombined;
        posInCombined += thisLength+1;
    }

    output.Save(offs,name+"_offs");
    output.Save(theCombinedStrings,name);
}

