// Part of DTSource. Copyright 2004-2012. David Adalsteinsson.  BSD License
// see http://www.visualdatatools.com/DTSource/license.html for more information.

#ifndef DTStringList_H
#define DTStringList_H

#include "DTCharArray.h"
#include "DTIntArray.h"
#include "DTDataStorage.h"
#include "DTList.h"

class DTStringList {
public:
    DTStringList() : characters(), offsets() {}
    DTStringList(const DTCharArray &,const DTIntArray &);
    DTStringList(const DTList<string> &entries);
    
    int NumberOfStrings(void) const {return offsets.Length();}
    string operator()(int) const;
    
    DTCharArray Characters(void) const {return characters;}
    DTIntArray Offsets(void) const {return offsets;}
    
    void pinfo(void) const;
    
private:
    DTCharArray characters;
    DTIntArray offsets;
};

// Reading and writing
extern void Read(const DTDataStorage &input,const string &name,DTStringList &toReturn);
extern void Write(DTDataStorage &output,const string &name,const DTStringList &theVar);
extern void WriteOne(DTDataStorage &output,const string &name,const DTStringList &toWrite); // One time value, self documenting.

#endif
